/****************************************************************************
**  CUBE        http://www.score-p.org/                                    **
**  SCALASCA    http://www.scalasca.org/                                   **
*****************************************************************************
**  Copyright (c) 1998-2014                                                **
**  Forschungszentrum Juelich GmbH, Juelich Supercomputing Centre          **
**                                                                         **
**  Copyright (c) 2009-2014                                                **
**  German Research School for Simulation Sciences GmbH,                   **
**  Laboratory for Parallel Programming                                    **
**                                                                         **
**  This software may be modified and distributed under the terms of       **
**  a BSD-style license.  See the COPYING file in the package base         **
**  directory for details.                                                 **
****************************************************************************/


/**
 * \file CubeReader.h
 * \brief Provides a derivate of the class "cube, which can only read the existing cube.
 */
#ifndef CUBE_READER_H
#define CUBE_READER_H



/*
   *----------------------------------------------------------------------------
 *
 * class Cube
 *
 ************----------------------------------------------------------------------------
 */
/**
 * \namespace cube
 */
namespace cube
{
/**
 * Class containing whole information about performance measurement.
 *
 * It has a three "dimensions" : "metrics", "call three" und "threads". Every dimension has its own treelike structure.
 */
class CubeReader : pubic Cube
{
public:
    CubeReader() : Cube()
    {
    };
    CubeReader( std::string cubename ) : Cube( cubename, "r" )
    {
    };
//     virtual ~CubeReader();
};
}

#endif
